# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from abc import ABC, abstractmethod
from queue import Queue
from typing import TYPE_CHECKING, Optional, Union

from sila2.server import FeatureImplementationBase, MetadataDict, ObservableCommandInstance

from .phcontroller_types import SetPH_Responses

if TYPE_CHECKING:
    from ...server import Server


class PHControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    _PHValue_producer_queue: Queue[Union[float, Exception]]
    _PHValue_current_value: float

    def __init__(self, parent_server: Server):
        """

        Controlling the pH in a reactor.

        """
        super().__init__(parent_server=parent_server)

        self._PHValue_producer_queue = Queue()

    def update_PHValue(self, PHValue: float, queue: Optional[Queue[float]] = None) -> None:
        """
        current pH Value

        This method updates the observable property 'PHValue'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._PHValue_producer_queue
            self._PHValue_current_value = PHValue
        queue.put(PHValue)

    def PHValue_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[float]]:
        """
        current pH Value

        This method is called when a client subscribes to the observable property 'PHValue'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def abort_PHValue_subscriptions(self, error: Exception, queue: Optional[Queue[float]] = None) -> None:
        """
        current pH Value

        This method aborts subscriptions to the observable property 'PHValue'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._PHValue_producer_queue
        queue.put(error)

    @property
    def current_PHValue(self) -> float:
        try:
            return self._PHValue_current_value
        except AttributeError:
            raise AttributeError("Observable property PHValue has never been set")

    @abstractmethod
    def SetPH(self, PH: float, *, metadata: MetadataDict, instance: ObservableCommandInstance) -> SetPH_Responses:
        """
        Setting the target pH


        :param PH: target pH

        :param metadata: The SiLA Client Metadata attached to the call
        :param instance: The command instance, enabling sending status updates to subscribed clients

        :return:

            - CurrentPH: Current pH


        """
        pass
